<!--
 - Created by MarosGrajcar on 8/27/2019.
 -->

<!-- Hog List View -->
<template>

    <div class="slds-grid slds-wrap slds-card slds-p-around--small">
        <span class="slds-size--6-of-12">
            <lightning-icon icon-name="standard:partners"></lightning-icon>
            <span class="slds-text-title_caps slds-p-left--x-small">
                Search Handover Forms
            </span>
        </span>

        <span if:false={showShiftSummaries} class="slds-size--6-of-12 slds-text-align--right slds-p-left--x-small">
            <lightning-button variant="success"
                              label="Open Selected Handovers"
                              onclick={openSelectedHandovers}>
            </lightning-button>
        </span>

        <span if:true={showShiftSummaries} class="slds-size--6-of-12 slds-text-align--right slds-p-left--x-small">
            <lightning-button variant="success"
                              label="Open Selected Shift Summaries"
                              onclick={openSelectedSummaries}>
            </lightning-button>
        </span>

    </div>

    <div class="slds-grid slds-wrap">

        <div class="slds-col slds-size_2-of-12 slds-p-around_x-small">
            <div class="slds-section slds-is-open slds-card slds-card_boundary">

                <div class="slds-m-around--small">

                    <c-elg_amu_lookup label="AMU"
                                      object-a-p-i-name="Field__c"
                                      amu-ids={postAMUs}
                                      placeholder="Choose AMU"
                                      render-icon="true"
                                      pre-selected-record={selectedAMU}
                                      onclearselection={clearAMU}
                                      onselection={handleAMU}>
                    </c-elg_amu_lookup>

                    <template if:true={showFilter}>
                        <div if:false={changeFilterCriteria} class="slds-m-top--small">

                            <lightning-combobox
                                    name="status"
                                    label="POST"
                                    placeholder="Choose Post"
                                    value={selectedPost}
                                    onchange={handleSelectedPost}
                                    options={amuPosts}>
                            </lightning-combobox>

                            <span if:true={postIsSelected} class="slds-button slds-button--icon slds-m-top--xxx-small"
                                  onclick={clearPostSelection}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>

                        </div>

                        <div class="slds-m-top--small">
                            <lightning-combobox
                                    name="status"
                                    label="SHIFT CYCLE"
                                    placeholder="Choose Shift Cycle"
                                    value={selectedShiftCycle}
                                    onchange={handleSelectedShiftCycle}
                                    options={shiftDayCycles}>
                            </lightning-combobox>

                            <span if:true={cycleIsSelected} class="slds-button slds-button--icon slds-m-top--xxx-small"
                                  onclick={clearCycleSelection}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>

                        </div>

                        <template if:true={showShiftSummaries}>
                            <div class="slds-m-top--small">
                                <lightning-combobox
                                        name="status"
                                        label="SHIFT SUMMARY STATUS"
                                        field-level-help="In Progress - Ongoing Shift; Awaiting Accept - Shift was Signed Off; Accepted - Shift was Signed Off and Signed In"
                                        placeholder="Choose Shift Summary Status"
                                        value={selectedShiftSummaryStatus}
                                        onchange={handleSelectedShiftSummaryStatus}
                                        options={shiftSummaryStatuses}>
                                </lightning-combobox>

                                <span if:true={statusIsSelected}
                                      class="slds-button slds-button--icon slds-m-top--xxx-small"
                                      onclick={clearStatusSelection}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>
                            </div>

                            <div class="slds-m-top--medium">

                                <c-hog_lookup label="OUTGOING SHIFT LEAD"
                                              object-a-p-i-name="User"
                                              placeholder="Choose Shift Lead"
                                              render-icon="true"
                                              icon-name="standard:people"
                                              onclearselection={clearShiftLead}
                                              onselection={handleSelectionPrimary}>
                                </c-hog_lookup>
                            </div>
                        </template>

                        <template if:false={showShiftSummaries}>
                            <div if:false={changeFilterCriteria} class="slds-m-top--small">
                                <lightning-combobox
                                        name="status"
                                        label="HANDOVER STATUS"
                                        field-level-help="Accepted - Handover is Accepted; In Progress - Handover is Awaiting Accept; New - Shift is In Progress (Before Sign Off)"
                                        placeholder="Choose Handover Status"
                                        value={selectedHandoverStatus}
                                        onchange={handleSelectedHandoverStatus}
                                        options={handoverStatuses}>
                                </lightning-combobox>

                                <span if:true={statusIsSelected}
                                      class="slds-button slds-button--icon slds-m-top--xxx-small"
                                      onclick={clearStatusSelection}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>
                            </div>

                            <div if:true={changeFilterCriteria} class="slds-m-top--small">
                                <lightning-combobox
                                        name="status"
                                        label="HANDOVER STATUS"
                                        field-level-help="Accepted - Handover is Accepted; In Progress - Handover is Awaiting Accept; New - Shift is In Progress (Before Sign Off)"
                                        placeholder="Choose Handover Status"
                                        value={selectedHandoverStatusReviews}
                                        onchange={handleSelectedHandoverStatusReviews}
                                        options={handoverStatusesForReviewers}>
                                </lightning-combobox>

                                <span if:true={statusIsSelected}
                                      class="slds-button slds-button--icon slds-m-top--xxx-small"
                                      onclick={clearStatusSelection}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>
                            </div>

                            <div class="slds-m-top--medium">

                                <c-hog_lookup label="OUTGOING OPERATOR"
                                              object-a-p-i-name="User"
                                              placeholder="Choose Primary"
                                              render-icon="true"
                                              icon-name="standard:people"
                                              onclearselection={clearPrimary}
                                              onselection={handleSelectionPrimary}>
                                </c-hog_lookup>
                            </div>

                            <template if:false={showDeciderCheckbox}>
                                <div class="slds-m-top--medium">
                                    <c-hog_lookup label="SHIFT ENGINEER"
                                                  object-a-p-i-name="User"
                                                  placeholder="Choose Shift Engineer"
                                                  render-icon="true"
                                                  icon-name="standard:people"
                                                  onclearselection={clearShiftEngineer}
                                                  onselection={handleSelectionShiftEngineer}>
                                    </c-hog_lookup>
                                </div>

                                <div class="slds-m-top--medium slds-box">
                                    <lightning-input label="Awaiting Review" type="checkbox"
                                                     checked={showReviewSelection}
                                                     onchange={handleReviewSelection}>
                                    </lightning-input>

                                    <div if:true={showReviewSelection} class="slds-m-top--medium slds-m-left--medium">
                                        <lightning-input class="slds-m-top--small"
                                                         label="by Shift Engineer" type="checkbox"
                                                         checked={shiftEngineerReview}
                                                         onchange={handleShiftEngineerReview}>
                                        </lightning-input>

                                        <lightning-input class="slds-m-top--small"
                                                         label="by Steam Chief" type="checkbox"
                                                         checked={steamChiefReview}
                                                         onchange={handleSteamChiefReview}>
                                        </lightning-input>

                                        <lightning-input class="slds-m-top--small"
                                                         label="by Shift Lead" type="checkbox"
                                                         checked={shiftLeadReview}
                                                         onchange={handleShiftLeadReview}>
                                        </lightning-input>

                                        <lightning-input class="slds-m-top--small"
                                                         label="by Sr. Supervisor" type="checkbox"
                                                         checked={supervisorReview}
                                                         onchange={handleSupervisorReview}>
                                        </lightning-input>
                                    </div>
                                </div>
                            </template>

                        </template>

                        <div class="slds-m-top--medium">
                            <lightning-input type="date"
                                             label="START DATE"
                                             placeholder="Choose Start Date"
                                             autocomplete="off"
                                             value={startDate}
                                             onchange={handleSelectedStartDate}>
                            </lightning-input>

                            <span if:true={startDateIsSelected}
                                  class="slds-button slds-button--icon slds-m-top--xxx-small"
                                  onclick={clearStartDate}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>

                        </div>

                        <div class="slds-m-top--small">
                            <lightning-input type="date"
                                             label="END DATE"
                                             placeholder="Choose End Date"
                                             autocomplete="off"
                                             value={endDate}
                                             onchange={handleSelectedEndDate}>
                            </lightning-input>

                            <span if:true={endDateIsSelected}
                                  class="slds-button slds-button--icon slds-m-top--xxx-small"
                                  onclick={clearEndDate}>
                                <lightning-icon icon-name="utility:close"
                                                size="xx-small">
                                </lightning-icon>
                                <span class="slds-assistive-text">
                                    Clear Selection
                                </span>
						    </span>

                        </div>

                        <template if:true={showDeciderCheckbox}>
                            <div class="slds-m-top--medium slds-box">
                                <lightning-input label="Search Handovers" type="checkbox"
                                                 checked={searchHandovers}
                                                 onchange={handleDeciderCheckbox}>
                                </lightning-input>
                            </div>
                        </template>

                        <div class="slds-m-top--medium">
                            <lightning-input label="Change default sort" type="checkbox" checked={checked}
                                             onchange={handleCheckboxChange}></lightning-input>
                        </div>

                        <div if:true={userSort} class="slds-m-top--medium">
                            <lightning-combobox
                                    name="sortBy"
                                    label="SORT BY FIELD"
                                    placeholder="Choose Field To Sort By"
                                    value={sortByField}
                                    onchange={handleSortByField}
                                    options={sortByFieldOptions}>
                            </lightning-combobox>
                            <div class="slds-m-top--medium">
                                <lightning-combobox
                                        name="sortingOrder"
                                        label="DIRECTION"
                                        placeholder="Choose Sorting Direction"
                                        value={sortingDirection}
                                        onchange={handleSortingDirection}
                                        options={sortByDirection}>
                                </lightning-combobox>
                            </div>
                        </div>

                    </template>
                </div>


                <div if:true={showFilter} class="slds-m-around--medium">
                    <template if:true={showSpinner}>
                        <lightning-spinner alternative-text="Loading"></lightning-spinner>
                    </template>
                    <lightning-button variant="neutral" label="Clear Selection"
                                      onclick={clearData}></lightning-button>
                    <lightning-button if:false={showShiftSummaries} variant="brand" label="Search"
                                      onclick={availableHandovers}></lightning-button>
                    <lightning-button if:true={showShiftSummaries} variant="brand" label="Search"
                                      onclick={availableShiftSummaries}></lightning-button>
                </div>

            </div>
        </div>

        <div if:false={showError} class="slds-col slds-size_10-of-12 slds-p-around_x-small">

            <template if:false={showShiftSummaries}>

                <div if:false={showReviewSelection} class="slds-section slds-is-open slds-card slds-card_boundary">
                    <template if:true={showSpinner}>
                        <lightning-spinner alternative-text="Loading"></lightning-spinner>
                    </template>

                    <lightning-datatable
                            key-field="id"
                            data={handovers}
                            columns={handoverColumns}>
                    </lightning-datatable>

                </div>

                <div if:true={showReviewSelection} class="slds-section slds-is-open slds-card slds-card_boundary">
                    <template if:true={showSpinner}>
                        <lightning-spinner alternative-text="Loading"></lightning-spinner>
                    </template>

                    <lightning-datatable
                            key-field="id"
                            data={handovers}
                            columns={handoverColumnsForSE}>
                    </lightning-datatable>
                </div>

            </template>

            <div if:true={showShiftSummaries} class="slds-section slds-is-open slds-card slds-card_boundary">
                <template if:true={showSpinner}>
                    <lightning-spinner alternative-text="Loading"></lightning-spinner>
                </template>

                <lightning-datatable
                        key-field="id"
                        class="blabla"
                        data={shiftSummaries}
                        columns={shiftSummaryColumns}>
                </lightning-datatable>

            </div>

            <div if:true={hasRecords}>

                <div class="slds-m-vertical_medium content">Total records: <b>{totalRecords} </b>
                    <span if:false={singlePage}>
                        Page <b> {currentPage}</b> of <b> {totalPages}</b>
                    </span>
                </div>

                <!--Pagination section later in standalone component-->
                <span if:false={singlePage}>

                <lightning-layout>
                    <lightning-layout-item>
                        <lightning-button label="First" icon-name="utility:chevronleft" onclick={handleFirst}
                                          disabled={showFirstButton}></lightning-button>
                    </lightning-layout-item>
                    <lightning-layout-item>
                        <lightning-button label="Previous" icon-name="utility:chevronleft" onclick={handlePrevious}
                                          disabled={showFirstButton}></lightning-button>
                    </lightning-layout-item>
                    <lightning-layout-item flexibility="grow"></lightning-layout-item>
                    <lightning-layout-item>
                        <lightning-button label="Next" icon-name="utility:chevronright" icon-position="right"
                                          onclick={handleNext}
                                          disabled={showLastButton}></lightning-button>
                    </lightning-layout-item>
                    <lightning-layout-item>
                        <lightning-button label="Last" icon-name="utility:chevronright" icon-position="right"
                                          onclick={handleLast}
                                          disabled={showLastButton}></lightning-button>
                    </lightning-layout-item>
                </lightning-layout>

                </span>

            </div>

        </div>

        <div if:true={showError} class="slds-col slds-size_10-of-12 slds-p-around_x-small">
            <div class="slds-section slds-is-open slds-card slds-card_boundary slds-align--absolute-center slds-text-heading_small slds-p-around--x-small">
                <b>{errorMessage}</b>
            </div>
        </div>

    </div>


</template>